#include "windows.h"
#define EVENTTABLEMAX 20
#define COMMANDMAX 50
typedef struct{
	UINT msg;
	void (*proc)(HWND hw, WPARAM wp,LPARAM lp);
	int Return; // return Ƃtrue
}EVENT_element;
int EVENT_counter, COMMAND_counter;
EVENT_element EVENT_table[EVENTTABLEMAX+1];
void (*command[COMMANDMAX+1])(HWND hw, WPARAM wp,LPARAM lp);
int EVENT_DEF(UINT msg,void (*proc)(HWND hw, WPARAM wp,LPARAM lp), int Return){
	if(EVENT_counter>=EVENTTABLEMAX)return 1;
	EVENT_table[EVENT_counter].msg=msg;
	EVENT_table[EVENT_counter].proc=proc;
	if(msg==WM_DESTROY)Return = false;
	EVENT_table[EVENT_counter].Return=Return;
	EVENT_counter++;
	return 0;
}
int COMMAND_DEF(void (*proc)(HWND hw, WPARAM wp,LPARAM lp)){
	if(COMMAND_counter>=COMMANDMAX) return -1;
	int r=COMMAND_counter+1000;
	command[COMMAND_counter++]=proc;
	return r;
}
void procCommand(HWND hw, WPARAM wp,LPARAM lp){
	int ID=(LOWORD(wp))-1000;
	if(ID>=0 && ID<COMMAND_counter){
		if(command[ID]!=NULL) command[ID](hw,wp,lp);
	}
}

void createButton(HWND *bt, HWND hw, TCHAR Caption[], int X, int Y, int W, int H, 
	void (*proc)(HWND hw, WPARAM wp,LPARAM lp)){
	*bt= CreateWindow(TEXT("BUTTON"),Caption, WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		X, Y, W, H, hw, (HMENU)COMMAND_DEF(proc), hInstance, NULL);
}
void createEdit(HWND *ed, HWND hw, TCHAR text[],int X, int Y, int W, int H, 
	void (*proc)(HWND hw, WPARAM wp,LPARAM lp)){
	*ed=CreateWindow(TEXT("EDIT"), text, WS_CHILD | WS_VISIBLE | WS_HSCROLL | 
		WS_VSCROLL | WS_BORDER | ES_AUTOHSCROLL | ES_AUTOVSCROLL| ES_LEFT | 
		ES_MULTILINE | ES_OEMCONVERT | ES_WANTRETURN,
		X, Y, W, H, hw, (HMENU)COMMAND_DEF(proc), hInstance, NULL);
}
void procCreate(HWND hw, WPARAM wp,LPARAM lp);
void procCreateEx(HWND hw, WPARAM wp,LPARAM lp){
	EVENT_counter=COMMAND_counter=0;
	procCreate(hw,wp,lp);
}
LRESULT CALLBACK WndProc(HWND hw, UINT msg, WPARAM wp,LPARAM lp){
	if(msg==WM_CREATE) { procCreateEx(hw, wp, lp);return 0;}
	if(msg==WM_COMMAND){ procCommand(hw, wp, lp);return 0;}
	for(int i=0;i<EVENT_counter;i++){
		if(msg==EVENT_table[i].msg){
			EVENT_table[i].proc(hw,wp,lp);
			if(EVENT_table[i].Return) return 0;
			break;
		}
	}
	if(msg==WM_DESTROY){PostQuitMessage(0); return 0;}
	return DefWindowProc(hw,msg,wp,lp);
}